diff --git a/pyanaconda/storage/formats/fs.py b/pyanaconda/storage/formats/fs.py
index 80c3e09..1d355c3 100644
--- a/pyanaconda/storage/formats/fs.py
+++ b/pyanaconda/storage/formats/fs.py
@@ -31,14 +31,13 @@ import os
 import sys
 import tempfile
 import selinux
-from pyanaconda import isys
 
 from ..errors import *
 from . import DeviceFormat, register_device_format
-from pyanaconda import iutil
-from pyanaconda.flags import flags
+from .. import util
+from ..flags import flags
 from parted import fileSystemType
-from pyanaconda.anaconda_log import log_method_call
+from ..storage_log import log_method_call
 
 import logging
 log = logging.getLogger("storage")
@@ -255,12 +254,12 @@ class FS(DeviceFormat):
         size = self._size
 
         if self.infofsProg and self.exists and not size and \
-           iutil.find_program_in_path(self.infofsProg):
+           util.find_program_in_path(self.infofsProg):
             try:
                 values = []
                 argv = self._defaultInfoOptions + [ self.device ]
 
-                buf = iutil.execWithCapture(self.infofsProg, argv)
+                buf = util.capture_output([self.infofsProg] + argv)
 
                 for line in buf.splitlines():
                     found = False
@@ -363,8 +362,8 @@ class FS(DeviceFormat):
         argv = self._getFormatOptions(options=options)
 
         try:
-            ret = iutil.execWithRedirect(self.mkfsProg, argv)
-        except Exception as e:
+            ret = util.run_program([self.mkfsProg] + argv)
+        except OSError as e:
             raise FormatCreateError(e, self.device)
 
         if ret:
@@ -416,9 +415,8 @@ class FS(DeviceFormat):
             log.info("Minimum size changed, setting targetSize on %s to %s" \
                      % (self.device, self.targetSize))
         try:
-            ret = iutil.execWithRedirect(self.resizefsProg,
-                                         self.resizeArgs)
-        except Exception as e:
+            ret = util.run_program([self.resizefsProg] + self.resizeArgs)
+        except OSError as e:
             raise FSResizeError(e, self.device)
 
         if ret:
@@ -453,9 +451,8 @@ class FS(DeviceFormat):
             raise FSError("device does not exist")
 
         try:
-            ret = iutil.execWithRedirect(self.fsckProg,
-                                         self._getCheckArgs())
-        except Exception as e:
+            ret = util.run_program([self.fsckProg] + self._getCheckArgs())
+        except OSError as e:
             raise FSError("filesystem check failed: %s" % e)
 
         if self._fsckFailed(ret):
@@ -474,8 +471,8 @@ class FS(DeviceFormat):
 
         for module in self._modules:
             try:
-                rc = iutil.execWithRedirect("modprobe", [module])
-            except Exception as e:
+                rc = util.run_program(["modprobe", module])
+            except OSError as e:
                 log.error("Could not load kernel module %s: %s" % (module, e))
                 self._supported = False
                 return
@@ -551,9 +548,9 @@ class FS(DeviceFormat):
         #
         #mountpoint = os.path.join(chroot, mountpoint)
         chrootedMountpoint = os.path.normpath("%s/%s" % (chroot, mountpoint))
-        iutil.mkdirChain(chrootedMountpoint)
+        util.makedirs(chrootedMountpoint)
         if flags.selinux:
-            ret = isys.resetFileContext(mountpoint, chroot)
+            ret = util.reset_file_context(mountpoint, chroot)
             log.info("set SELinux context for mountpoint %s to %s" \
                      % (mountpoint, ret))
 
@@ -561,11 +558,13 @@ class FS(DeviceFormat):
         if not options or not isinstance(options, str):
             options = self.options
 
+        if isinstance(self, BindFS):
+            options = "bind," + options
+
         try: 
-            rc = isys.mount(self.device, chrootedMountpoint, 
+            rc = util.mount(self.device, chrootedMountpoint,
                             fstype=self.mountType,
-                            options=options,
-                            bindMount=isinstance(self, BindFS))
+                            options=options)
         except Exception as e:
             raise FSError("mount failed: %s" % e)
 
@@ -573,11 +572,11 @@ class FS(DeviceFormat):
             raise FSError("mount failed: %s" % rc)
 
         if flags.selinux and "ro" not in options.split(","):
-            ret = isys.resetFileContext(mountpoint, chroot)
+            ret = util.reset_file_context(mountpoint, chroot)
             log.info("set SELinux context for newly mounted filesystem "
                      "root at %s to %s" %(mountpoint, ret))
-            isys.setFileContext("%s/lost+found" % mountpoint,
-                                lost_and_found_context, chroot)
+            util.set_file_context("%s/lost+found" % mountpoint,
+                               lost_and_found_context, chroot)
 
         self._mountpoint = chrootedMountpoint
 
@@ -593,7 +592,7 @@ class FS(DeviceFormat):
         if not os.path.exists(self._mountpoint):
             raise FSError("mountpoint does not exist")
 
-        rc = isys.umount(self._mountpoint, removeDir = False)
+        rc = util.umount(self._mountpoint)
         if rc:
             raise FSError("umount failed")
 
@@ -617,7 +616,7 @@ class FS(DeviceFormat):
             raise FSError("device does not exist")
 
         argv = self._getLabelArgs(label)
-        rc = iutil.execWithRedirect(self.labelfsProg, argv)
+        rc = util.run_program([self.labelfsProg] + argv)
         if rc:
             raise FSError("label failed")
 
@@ -625,7 +624,7 @@ class FS(DeviceFormat):
         self.notifyKernel()
 
     def _getRandomUUID(self):
-        uuid = iutil.execWithCapture("uuidgen", []).strip()
+        uuid = util.capture_output(["uuidgen"]).strip()
         return uuid
 
     def writeRandomUUID(self):
@@ -668,7 +667,7 @@ class FS(DeviceFormat):
             if not prog:
                 continue
 
-            if not iutil.find_program_in_path(prog):
+            if not util.find_program_in_path(prog):
                 return False
 
         return True
@@ -830,11 +829,8 @@ class Ext2FS(FS):
 
         err = None
         try:
-            rc = iutil.execWithRedirect("tune2fs",
-                                        ["-U",
-                                         "random",
-                                         self.device])
-        except Exception as e:
+            rc = util.run_program(["tune2fs", "-U", "random", self.device])
+        except OSError as e:
             err = str(e)
         else:
             if rc:
@@ -854,8 +850,7 @@ class Ext2FS(FS):
 
             if self.exists and os.path.exists(self.device):
                 # get block size
-                buf = iutil.execWithCapture(self.infofsProg,
-                                            ["-h", self.device])
+                buf = util.capture_output([self.infofsProg, "-h", self.device])
                 for line in buf.splitlines():
                     if line.startswith("Block size:"):
                         blockSize = int(line.split(" ")[-1])
@@ -869,8 +864,8 @@ class Ext2FS(FS):
                                   "on %s" % (self.mountType, self.device))
 
                 # get minimum size according to resize2fs
-                buf = iutil.execWithCapture(self.resizefsProg,
-                                            ["-P", self.device])
+                buf = util.capture_output([self.resizefsProg,
+                                           "-P", self.device])
                 for line in buf.splitlines():
                     if "minimum size of the filesystem:" not in line:
                         continue
@@ -1067,7 +1062,7 @@ class GFS2(FS):
     def supported(self):
         """ Is this filesystem a supported type? """
         supported = self._supported
-        if flags.cmdline.has_key("gfs2"):
+        if flags.gfs2:
             supported = self.utilsAvailable
 
         return supported
@@ -1099,7 +1094,7 @@ class JFS(FS):
     def supported(self):
         """ Is this filesystem a supported type? """
         supported = self._supported
-        if flags.cmdline.has_key("jfs"):
+        if flags.jfs:
             supported = self.utilsAvailable
 
         return supported
@@ -1133,7 +1128,7 @@ class ReiserFS(FS):
     def supported(self):
         """ Is this filesystem a supported type? """
         supported = self._supported
-        if flags.cmdline.has_key("reiserfs"):
+        if flags.reiserfs:
             supported = self.utilsAvailable
 
         return supported
@@ -1184,15 +1179,13 @@ class XFS(FS):
             return
 
         try:
-            iutil.execWithRedirect("xfs_freeze", ["-f", self.mountpoint],
-                                   root=root)
-        except (RuntimeError, OSError) as e:
+            util.run_program(["xfs_freeze", "-f", self.mountpoint], root=root)
+        except OSError as e:
             log.error("failed to run xfs_freeze: %s" % e)
 
         try:
-            iutil.execWithRedirect("xfs_freeze", ["-u", self.mountpoint],
-                                   root=root)
-        except (RuntimeError, OSError) as e:
+            util.run_program(["xfs_freeze", "-u", self.mountpoint], root=root)
+        except OSError as e:
             log.error("failed to run xfs_freeze: %s" % e)
 
 register_device_format(XFS)
@@ -1273,10 +1266,9 @@ class NTFS(FS):
             # we try one time to determine the minimum size.
             size = self._minSize
             if self.exists and os.path.exists(self.device) and \
-               iutil.find_program_in_path(self.resizefsProg):
+               util.find_program_in_path(self.resizefsProg):
                 minSize = None
-                buf = iutil.execWithCapture(self.resizefsProg,
-                                            ["-m", self.device])
+                buf = util.run_program([self.resizefsProg, "-m", self.device])
                 for l in buf.split("\n"):
                     if not l.startswith("Minsize"):
                         continue
diff --git a/pyanaconda/storage/formats/luks.py b/pyanaconda/storage/formats/luks.py
index 6bb8b64..4b37cb4 100644
--- a/pyanaconda/storage/formats/luks.py
+++ b/pyanaconda/storage/formats/luks.py
@@ -29,7 +29,7 @@ try:
 except ImportError:
     volume_key = None
 
-from pyanaconda.anaconda_log import log_method_call
+from ..storage_log import log_method_call
 from ..errors import *
 from ..devicelibs import crypto
 from . import DeviceFormat, register_device_format
diff --git a/pyanaconda/storage/formats/lvmpv.py b/pyanaconda/storage/formats/lvmpv.py
index 018d186..d804711 100644
--- a/pyanaconda/storage/formats/lvmpv.py
+++ b/pyanaconda/storage/formats/lvmpv.py
@@ -22,7 +22,7 @@
 
 import os
 
-from pyanaconda.anaconda_log import log_method_call
+from ..storage_log import log_method_call
 from parted import PARTITION_LVM
 from ..errors import *
 from ..devicelibs import lvm
diff --git a/pyanaconda/storage/formats/mdraid.py b/pyanaconda/storage/formats/mdraid.py
index c543434..9d1e26e 100644
--- a/pyanaconda/storage/formats/mdraid.py
+++ b/pyanaconda/storage/formats/mdraid.py
@@ -22,12 +22,12 @@
 
 import os
 
-from pyanaconda.anaconda_log import log_method_call
-from pyanaconda.flags import flags
+from ..storage_log import log_method_call
 from parted import PARTITION_RAID
 from ..errors import *
 from ..devicelibs import mdraid
 from . import DeviceFormat, register_device_format
+from ..flags import flags
 
 import gettext
 _ = lambda x: gettext.ldgettext("anaconda", x)
@@ -113,8 +113,7 @@ class MDRaidMember(DeviceFormat):
 # nodmraid -> Wether to use BIOS RAID or not
 # Note the anaconda cmdline has not been parsed yet when we're first imported,
 # so we can not use flags.dmraid here
-if not flags.cmdline.has_key("noiswmd") and \
-   not flags.cmdline.has_key("nodmraid"):
+if not flags.noiswmd and flags.dmraid:
     MDRaidMember._udevTypes.append("isw_raid_member")
 
 register_device_format(MDRaidMember)
diff --git a/pyanaconda/storage/formats/multipath.py b/pyanaconda/storage/formats/multipath.py
index b77de20..01d69ee 100644
--- a/pyanaconda/storage/formats/multipath.py
+++ b/pyanaconda/storage/formats/multipath.py
@@ -24,7 +24,7 @@
 # Red Hat Author(s): Peter Jones <pjones@redhat.com>
 #
 
-from pyanaconda.anaconda_log import log_method_call
+from ..storage_log import log_method_call
 from ..errors import *
 from . import DeviceFormat, register_device_format
 
diff --git a/pyanaconda/storage/formats/swap.py b/pyanaconda/storage/formats/swap.py
index 2267d68..903fe6e 100644
--- a/pyanaconda/storage/formats/swap.py
+++ b/pyanaconda/storage/formats/swap.py
@@ -20,10 +20,10 @@
 # Red Hat Author(s): Dave Lehman <dlehman@redhat.com>
 #
 
-from pyanaconda.iutil import numeric_type
 from parted import PARTITION_SWAP, fileSystemType
-from pyanaconda.anaconda_log import log_method_call
+from ..storage_log import log_method_call
 from ..errors import *
+from ..util import numeric_type
 from ..devicelibs import swap
 from . import DeviceFormat, register_device_format
 
diff --git a/pyanaconda/storage/iscsi.py b/pyanaconda/storage/iscsi.py
index 78ce1a6..4e64335 100644
--- a/pyanaconda/storage/iscsi.py
+++ b/pyanaconda/storage/iscsi.py
@@ -19,17 +19,17 @@
 #
 
 from pyanaconda.constants import *
-from udev import *
+from udev import udev_settle
+from . import util
+from .flags import flags
 import os
-from pyanaconda import iutil
-from pyanaconda.flags import flags
 import logging
 import shutil
 import time
 import hashlib
 import random
 import itertools
-log = logging.getLogger("anaconda")
+log = logging.getLogger("storage")
 
 import gettext
 _ = lambda x: gettext.ldgettext("anaconda", x)
@@ -53,7 +53,7 @@ def has_iscsi():
         return False
 
     if not ISCSID:
-        location = iutil.find_program_in_path("iscsid")
+        location = util.find_program_in_path("iscsid")
         if not location:
             return False
         ISCSID = location
@@ -197,13 +197,12 @@ class iscsi(object):
         for iface in ifaces:
             iscsi_iface_name = "iface%d" % len(self.ifaces)
             #iscsiadm -m iface -I iface0 --op=new
-            iutil.execWithRedirect("iscsiadm",
-                                   ["-m", "iface", "-I", iscsi_iface_name, "--op=new"])
+            util.run_program(["iscsiadm", "-m", "iface",
+                              "-I", iscsi_iface_name, "--op=new"])
             #iscsiadm -m iface -I iface0 --op=update -n iface.net_ifacename -v eth0
-            iutil.execWithRedirect("iscsiadm",
-                                   ["-m", "iface", "-I", iscsi_iface_name,
-                                    "--op=update", "-n",
-                                    "iface.net_ifacename", "-v", iface])
+            util.run_program(["iscsiadm", "-m", "iface",
+                              "-I", iscsi_iface_name, "--op=update",
+                              "-n", "iface.net_ifacename", "-v", iface])
 
             self.ifaces[iscsi_iface_name] = iface
             log.debug("created_interface %s:%s" % (iscsi_iface_name, iface))
@@ -213,9 +212,8 @@ class iscsi(object):
             return None
         for iscsi_iface_name in self.ifaces:
             #iscsiadm -m iface -I iface0 --op=delete
-            iutil.execWithRedirect("iscsiadm",
-                                   ["-m", "iface", "-I", iscsi_iface_name,
-                                    "--op=delete"])
+            util.run_program(["iscsiadm", "-m", "iface",
+                              "-I", iscsi_iface_name, "--op=delete"])
         self.ifaces = {}
 
     def startup(self):
@@ -246,19 +244,19 @@ class iscsi(object):
                 os.makedirs(fulldir, 0755)
 
         log.info("iSCSI startup")
-        iutil.execWithRedirect('modprobe', ['-a'] + ISCSI_MODULES)
+        util.run_program(['modprobe', '-a'] + ISCSI_MODULES)
         # iscsiuio is needed by Broadcom offload cards (bnx2i). Currently
         # not present in iscsi-initiator-utils for Fedora.
         try:
-            iscsiuio = iutil.find_program_in_path('iscsiuio',
+            iscsiuio = util.find_program_in_path('iscsiuio',
                                                    raise_on_error=True)
         except RuntimeError:
             log.info("iscsi: iscsiuio not found.")
         else:
             log.debug("iscsi: iscsiuio is at %s" % iscsiuio)
-            iutil.execWithRedirect(iscsiuio, [])
+            util.run_program([iscsiuio])
         # run the daemon
-        iutil.execWithRedirect(ISCSID, [])
+        util.run_program([ISCSID])
         time.sleep(1)
 
         self._startIBFT()
diff --git a/pyanaconda/storage/partitioning.py b/pyanaconda/storage/partitioning.py
index 87372fa..64aa250 100644
--- a/pyanaconda/storage/partitioning.py
+++ b/pyanaconda/storage/partitioning.py
@@ -27,9 +27,6 @@ from operator import add, sub, gt, lt
 import parted
 from pykickstart.constants import *
 
-from pyanaconda.constants import *
-from pyanaconda.errors import *
-
 from errors import *
 from deviceaction import *
 from devices import PartitionDevice, LUKSDevice, devicePathToName
diff --git a/pyanaconda/storage/storage_log.py b/pyanaconda/storage/storage_log.py
new file mode 100644
index 0000000..62ad86f
--- /dev/null
+++ b/pyanaconda/storage/storage_log.py
@@ -0,0 +1,46 @@
+import inspect
+import logging
+
+log = logging.getLogger("storage")
+log.addHandler(logging.NullHandler())
+
+def function_name_and_depth():
+    IGNORED_FUNCS = ["function_name_and_depth",
+                     "log_method_call",
+                     "log_method_return"]
+    stack = inspect.stack()
+
+    for i, frame in enumerate(stack):
+        methodname = frame[3]
+        if methodname not in IGNORED_FUNCS:
+            return (methodname, len(stack) - i)
+
+    return ("unknown function?", 0)
+
+def log_method_call(d, *args, **kwargs):
+    classname = d.__class__.__name__
+    (methodname, depth) = function_name_and_depth()
+    spaces = depth * ' '
+    fmt = "%s%s.%s:"
+    fmt_args = [spaces, classname, methodname]
+
+    for arg in args:
+        fmt += " %s ;"
+        fmt_args.append(arg)
+
+    for k, v in kwargs.items():
+        fmt += " %s: %s ;"
+        if "pass" in k.lower() and v:
+            v = "Skipped"
+        fmt_args.extend([k, v])
+
+    logging.getLogger("storage").debug(fmt % tuple(fmt_args))
+
+def log_method_return(d, retval):
+    classname = d.__class__.__name__
+    (methodname, depth) = function_name_and_depth()
+    spaces = depth * ' '
+    fmt = "%s%s.%s returned %s"
+    fmt_args = (spaces, classname, methodname, retval)
+    logging.getLogger("storage").debug(fmt % fmt_args)
+
diff --git a/pyanaconda/storage/udev.py b/pyanaconda/storage/udev.py
index 0510184..cb9601b 100644
--- a/pyanaconda/storage/udev.py
+++ b/pyanaconda/storage/udev.py
@@ -23,7 +23,7 @@
 import os
 import re
 
-from pyanaconda import iutil
+import util
 from errors import *
 from pyanaconda.baseudev import *
 
@@ -270,7 +270,7 @@ def udev_device_get_wwid(udev_info):
     """ The WWID of a device is typically just its serial number, but with
         colons in the name to make it more readable. """
     serial = udev_device_get_serial(udev_info)
-    return iutil.insert_colons(serial) if serial else ""
+    return util.insert_colons(serial) if serial else ""
 
 def udev_device_get_vendor(udev_info):
     """ Get the vendor of the device as reported by udev. """
diff --git a/pyanaconda/storage/util.py b/pyanaconda/storage/util.py
new file mode 100644
index 0000000..c80841b
--- /dev/null
+++ b/pyanaconda/storage/util.py
@@ -0,0 +1,272 @@
+import os
+import selinux
+import subprocess
+
+from size import Size
+
+import logging
+log = logging.getLogger("storage")
+program_log = logging.getLogger("program")
+
+def _run_program(argv, root='/', stdin=None, env_prune=None):
+    if env_prune is None:
+        env_prune = []
+
+    def chroot():
+        if root and root != '/':
+            os.chroot(root)
+
+    program_log.info("Running... %s" % argv)
+
+    env = os.environ.copy()
+    env.update({"LC_ALL": "C",
+                "INSTALL_PATH": root})
+    for var in env_prune:
+        env.pop(var, None)
+
+    try:
+        proc = subprocess.Popen(argv,
+                                stdin=stdin,
+                                stdout=subprocess.PIPE,
+                                stderr=subprocess.STDOUT,
+                                preexec_fn=chroot, cwd=root, env=env)
+
+        while True:
+            out = proc.communicate()[0]
+            if out:
+                for line in out.splitlines():
+                    program_log.info(line)
+
+            if proc.returncode is not None:
+                break
+    except OSError as e:
+        program_log.error("Error running %s: %s" % (argv[0], e.strerror))
+        raise
+
+    program_log.debug("Return code: %d" % proc.returncode)
+    return (proc.returncode, out)
+
+def run_program(*args, **kwargs):
+    return _run_program(*args, **kwargs)[0]
+
+def capture_output(*args, **kwargs):
+    return _run_program(*args, **kwargs)[1]
+
+def mount(device, mountpoint, fstype, options=None):
+    if options is None:
+        options = "defaults"
+
+    mountpoint = os.path.normpath(mountpoint)
+    if not os.path.exists(mountpoint):
+        makedirs(mountpoint)
+
+    argv = ["mount", "-t", fstype, "-o", options, device, mountpoint]
+    try:
+        rc = run_program(argv)
+    except OSError as e:
+        raise
+
+    return rc
+
+def umount(mountpoint):
+    try:
+        rc = run_program(["umount", mountpoint])
+    except OSError as e:
+        raise
+
+    return rc
+
+def total_memory():
+    """ Return the amount of system RAM in kilobytes. """
+    lines = open("/proc/meminfo").readlines()
+    for line in lines:
+        if line.startswith("MemTotal:"):
+            mem = long(line.split()[1])
+
+    return mem
+
+##
+## sysfs functions
+##
+def notify_kernel(path, action="change"):
+    """ Signal the kernel that the specified device has changed.
+
+        Exceptions raised: ValueError, IOError
+    """
+    log.debug("notifying kernel of '%s' event on device %s" % (action, path))
+    path = os.path.join(path, "uevent")
+    if not path.startswith("/sys/") or not os.access(path, os.W_OK):
+        log.debug("sysfs path '%s' invalid" % path)
+        raise ValueError("invalid sysfs path")
+
+    f = open(path, "a")
+    f.write("%s\n" % action)
+    f.close()
+
+def get_sysfs_attr(path, attr):
+    if not attr:
+        log.debug("get_sysfs_attr() called with attr=None")
+        return None
+
+    attribute = "/sys%s/%s" % (path, attr)
+    attribute = os.path.realpath(attribute)
+
+    if not os.path.isfile(attribute) and not os.path.islink(attribute):
+        log.warning("%s is not a valid attribute" % (attr,))
+        return None
+
+    return open(attribute, "r").read().strip()
+
+def get_sysfs_path_by_name(dev_node, class_name="block"):
+    """ Return sysfs path for a given device.
+
+        For a device node (e.g. /dev/vda2) get the respective sysfs path
+        (e.g. /sys/class/block/vda2). This also has to work for device nodes
+        that are in a subdirectory of /dev like '/dev/cciss/c0d0p1'.
+     """
+    dev_name = os.path.basename(dev_node)
+    if dev_node.startswith("/dev/"):
+        dev_name = dev_node[5:].replace("/", "!")
+    sysfs_class_dir = "/sys/class/%s" % class_name
+    dev_path = os.path.join(sysfs_class_dir, dev_name)
+    if os.path.exists(dev_path):
+        return dev_path
+    else:
+        raise RuntimeError("get_sysfs_path_by_name: Could not find sysfs path "
+                           "for '%s' (it is not at '%s')" % (dev_node, dev_path))
+
+##
+## SELinux functions
+##
+def match_path_context(path):
+    """ Return the default SELinux context for the given path. """
+    context = None
+    try:
+        context = selinux.matchpathcon(os.path.normpath(path), 0)[1]
+    except OSError as e:
+        log.info("failed to get default SELinux context for %s: %s" % (path, e))
+
+    return context
+
+def set_file_context(path, context, root=None):
+    """ Set the SELinux file context of a file.
+
+        Arguments:
+
+            path        filename string
+            context     context string
+
+        Keyword Arguments:
+
+            root        an optional chroot string
+
+        Return Value:
+
+            True if successful, False if not.
+    """
+    if root is None:
+        root = '/'
+
+    full_path = os.path.normpath("%s/%s" % (root, path))
+    if context is None or not os.access(full_path, os.F_OK):
+        return False
+
+    try:
+        rc = (selinux.lsetfilecon(full_path, context) == 0)
+    except OSError as e:
+        log.info("failed to set SELinux context for %s: %s" % (full_path, e))
+        rc = False
+
+    return rc
+
+def reset_file_context(path, root=None):
+    """ Restore the SELinux context of a file to its default value.
+
+        Arguments:
+
+            path        filename string
+
+        Keyword Arguments:
+
+            root        an optional chroot string
+
+        Return Value:
+
+            If successful, returns the file's new/default context.
+    """
+    context = match_path_context(path)
+    if context:
+        if set_file_context(path, context, root=root):
+            return context
+
+##
+## Miscellaneous
+##
+def find_program_in_path(prog, raise_on_error=False):
+    for d in os.environ["PATH"].split(os.pathsep):
+        full = os.path.join(d, prog)
+        if os.access(full, os.X_OK):
+            return full
+
+    if raise_on_error:
+        raise RuntimeError("Unable to locate a needed executable: '%s'" % prog)
+
+def makedirs(path):
+    if not os.path.isdir(path):
+        os.makedirs(path, 0755)
+
+def copy_to_system(source):
+    if not os.access(source, os.R_OK):
+        log.info("copy_to_system: source '%s' does not exist." % source)
+        return False
+
+    target = ROOT_PATH + source
+    target_dir = os.path.dirname(target)
+    log.debug("copy_to_system: '%s' -> '%s'." % (source, target))
+    if not os.path.isdir(target_dir):
+        os.makedirs(target_dir)
+    shutil.copy(source, target)
+    return True
+
+def lsmod():
+    """ Returns list of names of all loaded modules. """
+    with open("/proc/modules") as f:
+        lines = f.readlines()
+    return [l.split()[0] for l in lines]
+
+def get_option_value(opt_name, options):
+    """ Return the value of a named option in the specified options string. """
+    for opt in options.split(","):
+        if "=" not in opt:
+            continue
+
+        name, val = opt.split("=")
+        if name == opt_name:
+            return val.strip()
+
+def numeric_type(num):
+    """ Verify that a value is given as a numeric data type.
+
+        Return the number if the type is sensible or raise ValueError
+        if not.
+    """
+    if num is None:
+        num = 0
+    elif not (isinstance(num, int) or \
+              isinstance(num, long) or \
+              isinstance(num, float)):
+        raise ValueError("value (%s) must be either a number or None" % num)
+
+    return num
+
+def insert_colons(a_string):
+    """ Insert colon between every second character.
+
+        E.g. creates 'al:go:ri:th:ms' from 'algoritms'. Useful for formatting
+        MAC addresses and wwids for output.
+    """
+    suffix = a_string[-2:]
+    if len(a_string) > 2:
+        return insert_colons(a_string[:-2]) + ':' + suffix
+    else:
+        return suffix
diff --git a/pyanaconda/storage/zfcp.py b/pyanaconda/storage/zfcp.py
index 28b2317..27dd107 100644
--- a/pyanaconda/storage/zfcp.py
+++ b/pyanaconda/storage/zfcp.py
@@ -23,13 +23,13 @@ import string
 import os
 from pyanaconda.constants import *
 from udev import udev_settle
+from . import util
 
 import gettext
 _ = lambda x: gettext.ldgettext("anaconda", x)
 
-from pyanaconda import iutil
 import logging
-log = logging.getLogger("anaconda")
+log = logging.getLogger("storage")
 
 def loggedWriteLineToFile(fn, value):
     f = open(fn, "w")
@@ -125,7 +125,7 @@ class ZFCPDevice:
 
         if not os.path.exists(online):
             log.info("Freeing zFCP device %s" % (self.devnum,))
-            iutil.execWithRedirect("zfcp_cio_free", ["-d", self.devnum])
+            util.run_program(["zfcp_cio_free", "-d", self.devnum])
 
         if not os.path.exists(online):
             raise ValueError, _(
diff --git a/pyanaconda/timezone.py b/pyanaconda/timezone.py
index 6e8709b..01edeb3 100644
--- a/pyanaconda/timezone.py
+++ b/pyanaconda/timezone.py
@@ -30,6 +30,7 @@ from collections import OrderedDict
 
 from pyanaconda import localization
 from pyanaconda import iutil
+from pyanaconda.storage import arch
 
 import logging
 log = logging.getLogger("anaconda")
@@ -105,7 +106,7 @@ def save_hw_clock(timezone):
 
     """
 
-    if iutil.isS390():
+    if arch.isS390():
         return
 
     cmd = "hwclock"
diff --git a/tests/pyanaconda_test/network_test.py b/tests/pyanaconda_test/network_test.py
index a5afbe6..756c11d 100644
--- a/tests/pyanaconda_test/network_test.py
+++ b/tests/pyanaconda_test/network_test.py
@@ -211,8 +211,8 @@ class NetworkTest(mock.TestCase):
 
     def networkdevice_str_test(self):
         import pyanaconda.network
-        pyanaconda.network.iutil = mock.Mock()
-        pyanaconda.network.iutil.isS390.return_value = False
+        pyanaconda.network.arch = mock.Mock()
+        pyanaconda.network.arch.isS390.return_value = False
 
         nd = pyanaconda.network.NetworkDevice(self.NETSCRIPTSDIR, self.DEVICE)
         nd.info = {'HWADDR': '00:11:22:50:55:50', 'DEVICE': 'eth0', 'TYPE': 'Ethernet'}
@@ -381,8 +381,8 @@ class NetworkTest(mock.TestCase):
 
     def iface_for_host_ip_test(self):
         import pyanaconda.network
-        pyanaconda.network.iutil = mock.Mock()
-        pyanaconda.network.iutil.execWithCapture.return_value = \
+        pyanaconda.network.arch = mock.Mock()
+        pyanaconda.network.arch.execWithCapture.return_value = \
             "10.0.0.2 dev eth0  src 10.0.0.1"
 
         ret = pyanaconda.network.ifaceForHostIP('10.0.0.2')
-- 
1.7.6.5

